/*
 * ============LICENSE_START=======================================================
 * ONAP : ccsdk features
 * ================================================================================
 * Copyright (C) 2019 highstreet technologies GmbH Intellectual Property.
 * All rights reserved.
 * ================================================================================
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ============LICENSE_END=========================================================
 *
 */
package org.onap.ccsdk.features.sdnr.wt.common;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.Arrays;

/**
 * 
 * @author Michael Dürre
 *
 */
public class HtAssert {


    public static class HtNullable<T> {
    }

    public static void nonnull(Object... oList) {
        for (Object o : oList) {
            if (o == null) {
                throw new IllegalArgumentException("One of the date parameters in [" + whoCalledMe() + "] is null ("
                        + Arrays.toString(oList) + ")");

            }
        }

    };

    public static String whoCalledMe() {
        StackTraceElement[] stackTraceElements = Thread.currentThread().getStackTrace();
        StackTraceElement caller = stackTraceElements[3];
        String classname = caller.getClassName();
        String methodName = caller.getMethodName();
        int lineNumber = caller.getLineNumber();
        return classname + "." + methodName + ":" + lineNumber;
    }

    public static String whoCalledMeAll() {
        //		StackTraceElement[] stackTraceElements = Thread.currentThread().getStackTrace();
        //		StringBuilder line =new StringBuilder();
        //		for(StackTraceElement caller:stackTraceElements) {
        //			line.append(String.format("%s | %s:%d\n",caller.getClassName(),caller.getMethodName(),caller.getLineNumber()));
        //		}
        //		return line.toString();
        StringWriter sw = new StringWriter();
        PrintWriter pw = new PrintWriter(sw);
        new Throwable().printStackTrace(pw);
        return sw.toString();
    }

}
